<?php

/*
Plugin Name: WP-chgFontSize
Plugin URI: http://www.rodenas.org/blog/2007/03/08/wp-chgfontsize/
Description: Allows users to dynamically change the font size.
Version: 1.0
Author: Ferran Rodenas
Author URI: http://www.rodenas.org/blog/
*/

/*
 Copyright 2007 Ferran Rodenas (email: frodenas@gmail.com)

 This program is free software; you can redistribute it and/or modify it under the terms
 of the GNU General Public License as published by the Free Software Foundation; either
 version 2 of the License, or any later version.

 This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
 without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

 You should have received a copy of the GNU General Public License along with this program;
 if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 MA  02111-1307  USA
*/

/* Changelog
 * March 8 2007 - v1.0
   - Initial release
*/

// Options functions
function add_chgfontsize_options_page() {
	if (function_exists('add_options_page')) {
		add_options_page('Font Size Options', 'Font Size', 8, basename(__FILE__), 'add_chgfontsize_options_panel');
	}
}

function add_chgfontsize_options_panel() {
	if (isset($_POST['info_update'])) {
		// DOM Base Element option
		if (empty($_POST['chgfontsize_div_element'])) {
			$chgfontsize_div_element = '';
			delete_option('chgfontsize_div_element');
			$msg_desc = "Your settings have been saved.";
		} else {
			$chgfontsize_div_element = $_POST['chgfontsize_div_element'];
			update_option('chgfontsize_div_element', $chgfontsize_div_element);
			$msg_desc = "Your settings have been saved.";
		}
		// Font size option
		if (empty($_POST['chgfontsize_font_size'])) {
			$chgfontsize_font_size = '';
			delete_option('chgfontsize_font_size');
			$msg_desc = "Your settings have been saved.";
		} else {
			$chgfontsize_font_size = $_POST['chgfontsize_font_size'];
			if ($chgfontsize_font_size >= 8 && $chgfontsize_font_size <= 24) {
				update_option('chgfontsize_font_size', $chgfontsize_font_size);
				$msg_desc = "Your settings have been saved.";

			} else {
				$msg_desc = "Incorrect Font Size: Value must be between 8 and 24.";
			}
		}
		// Display Text option
		if (empty($_POST['chgfontsize_display_text'])) {
			$chgfontsize_display_text = '';
			delete_option('chgfontsize_display_text');
			$msg_desc = "Your settings have been saved.";
		} else {
			$chgfontsize_display_text = 'on';
			update_option('chgfontsize_display_text', $chgfontsize_display_text);
			$msg_desc = "Your settings have been saved.";
		}
		// Display Image option
		if (empty($_POST['chgfontsize_display_image'])) {
			$chgfontsize_display_image = '';
			delete_option('chgfontsize_display_image');
			$msg_desc = "Your settings have been saved.";
		} else {
			$chgfontsize_display_image = 'on';
			update_option('chgfontsize_display_image', $chgfontsize_display_image);
			$msg_desc = "Your settings have been saved.";
		}
		if ($msg_desc != '') echo '<div id="message" class="updated fade"><p>' . $msg_desc . '</p></div>';
	} else {
		$chgfontsize_div_element = get_option('chgfontsize_div_element');
		$chgfontsize_font_size = get_option('chgfontsize_font_size');
		$chgfontsize_display_text = get_option('chgfontsize_display_text');
		$chgfontsize_display_image = get_option('chgfontsize_display_image');
	}

	echo '<div class="wrap">';
	echo '<h2>Font Size options</h2>';
	echo '<p>Use this page to configure the default values:</p>';
	echo '<form name="formchgfontsize" method="post" action="' . $_SERVER['REQUEST_URI'] . '">';
	echo '<fieldset class="options">';
        echo '<table>';
	echo '<tr>';
	echo '<th><label for="chgfontsize_div_element">DIV Base Element:</label></th>';
	echo '<td><input type="text" name="chgfontsize_div_element" value="' . $chgfontsize_div_element . '" /> (e.g. content)</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<th><label for="chgfontsize_font_size">Default Font Size:</label></th>';
	echo '<td><select name="chgfontsize_font_size">';
	for ($size = 8; $size <= 24; $size++) {
		if ($size == $chgfontsize_font_size) {
			echo '<option value="' . $size . '" selected="selected">' . $size . '</option>';
		} else {
			echo '<option value="' . $size . '">' . $size . '</option>';
		}
	}
	echo '</select> pixels (Value between 8 and 24)</td>';
	echo '</tr>';
	echo '<tr>';
	echo '<th><label for="chgfontsize_display">Display Font Size Values as:</label></th>';
        if ($chgfontsize_display_text == 'on') { 
		$chgfontsize_display_text_checked = 'checked="checked"';
	} else {
		$chgfontsize_display_text_checked = '';
	}
        if ($chgfontsize_display_image == 'on') { 
		$chgfontsize_display_image_checked = 'checked="checked"';
	} else {
		$chgfontsize_display_image_checked = '';
	}
	echo '<td><input type="checkbox" name="chgfontsize_display_text" ' . $chgfontsize_display_text_checked . ' /> Text<br /><input type="checkbox" name="chgfontsize_display_image" ' . $chgfontsize_display_image_checked . ' /> Image</td>';
	echo '</tr>';
	echo '</table>';
	echo '</fieldset>';
	echo '<p class="submit"><input type="submit" name="info_update" value="Update Options &raquo;" /></p>';
	echo '<p><strong>Info</strong>: This plugin stores two options in the WordPress database. By leaving the above fields empty and hitting the &quot;<em>Update Options</em>&quot;';
	echo '	button, the options are removed from the WordPress database. Although it is not necessary, you should consider doing this before uninstalling the plugin, so no trace is left behind.</p>';
	echo '</form>';
	echo '</div>';
}

// Header functions
function add_chgfontsize_js() {
	echo "\n<script src=\"" . get_bloginfo('url') . "/wp-content/plugins/wp-chgfontsize/wp-chgfontsize.js\" type=\"text/javascript\"></script>\n";
}

// Plugin functions
function chgfontsize_display_options() {
	// Get the options from the Database
	$chgfontsize_div_element = get_option('chgfontsize_div_element');
	$chgfontsize_font_size = get_option('chgfontsize_font_size');
	$chgfontsize_display_text = get_option('chgfontsize_display_text');
	$chgfontsize_display_image = get_option('chgfontsize_display_image');

	// Insert call to javascript function
	echo "\n<script language=\"JavaScript\" type=\"text/javascript\">\n";
	echo "<!--\n";
	echo "chgfontsize_element = '" . $chgfontsize_div_element . "';\n";
	echo "chgfontsize_font_size = getCookie('fontsize');\n";
	echo "if (chgfontsize_font_size == null) { chgfontsize_font_size = " . $chgfontsize_font_size . "; }\n";
	if ($chgfontsize_display_image == 'on') {
		echo "chgfontsize_imgdecact = new Image();\n";
		echo "chgfontsize_imgdecact.src = '" . get_bloginfo('url') . "/wp-content/plugins/wp-chgfontsize/decrease_activated.gif';\n";
		echo "chgfontsize_imgdecdea = new Image();\n";
		echo "chgfontsize_imgdecdea.src = '" . get_bloginfo('url') . "/wp-content/plugins/wp-chgfontsize/decrease_deactivated.gif';\n";
		echo "chgfontsize_imgincact = new Image();\n";
		echo "chgfontsize_imgincact.src = '" . get_bloginfo('url') . "/wp-content/plugins/wp-chgfontsize/increase_activated.gif';\n";
		echo "chgfontsize_imgincdea = new Image();\n";
		echo "chgfontsize_imgincdea.src = '" . get_bloginfo('url') . "/wp-content/plugins/wp-chgfontsize/increase_deactivated.gif';\n";
	}
	echo "chgFontSize_display('" . $chgfontsize_display_text . "', '" . $chgfontsize_display_image . "');\n";
	echo "chgFontSize();\n";
	echo "//-->\n";
	echo "</script>\n";
}

add_action('wp_head', 'add_chgfontsize_js');
add_action('admin_menu', 'add_chgfontsize_options_page');

?>